<?php

declare(strict_types=1);

/*
 * Chill is a software for social workers
 *
 * For the full copyright and license information, please view
 * the LICENSE file that was distributed with this source code.
 */

namespace Chill\MainBundle\Form;

use Chill\MainBundle\Entity\SavedExport;
use Chill\MainBundle\Form\Type\ChillTextareaType;
use Chill\MainBundle\Form\Type\PickUserGroupOrUserDynamicType;
use Chill\MainBundle\Security\Authorization\SavedExportVoter;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Security\Core\Security;

class SavedExportType extends AbstractType
{
    public function __construct(private readonly Security $security) {}

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $savedExport = $options['data'];

        $builder
            ->add('title', TextType::class, [
                'required' => true,
            ])
            ->add('description', ChillTextareaType::class, [
                'required' => false,
            ]);

        if ($this->security->isGranted(SavedExportVoter::SHARE, $savedExport)) {
            $builder->add('share', PickUserGroupOrUserDynamicType::class, [
                'multiple' => true,
                'required' => false,
                'label' => 'saved_export.Share',
            ]);
        }
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'class' => SavedExport::class,
        ]);
    }
}
